Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 4901)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 1)
@@ -1,146 +1,66 @@
-!> @file init_grid.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ SUBROUTINE init_grid
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
-!
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! Height of level k=0 for the u,v-grid is always set 0.0,
-! small changes to follow coding standard
-!
-! 4828 2021-01-05 11:21:41Z Giersch
-! Bugfix in building mapping when static driver is available but no actual building is present
-! within the model domain
-!
-! 4691 2020-09-22 14:38:38Z suehring
-! Reference model topography to the lowest grid point also in ASCII input case
-!
-! 4653 2020-08-27 08:54:43Z pavelkrc
-! file re-formatted to follow the PALM coding standard
-!
-! 4630 2020-07-30 14:54:34Z suehring
-! In case of ASCII topography input flag grid points as terrain and building.
-!
-! 4601 2020-07-14 12:06:09Z suehring
-! Minor formatting adjustments
-!
-! 4564 2020-06-12 14:03:36Z raasch
-! Vertical nesting method of Huq et al. (2019) removed
-!
-! 4543 2020-05-20 14:12:22Z gronemeier
-! Remove non-required check for canyon height
-!
-! 4507 2020-04-22 18:21:45Z gronemeier
-! update origin_z with shifting height of orography (oro_min)
-!
-! 4457 2020-03-11 14:20:43Z raasch
-! use statement for exchange horiz added,
-! bugfix for call of exchange horiz 2d
-!
-! 4444 2020-03-05 15:59:50Z raasch
-! bugfix: cpp-directives for serial mode added
-!
-! 4414 2020-02-19 20:16:04Z suehring
-! - Remove deprecated topography arrays nzb_s_inner, nzb_u_inner, etc.
-! - Move initialization of boundary conditions and multigrid into an extra module interface.
-!
-! 4386 2020-01-27 15:07:30Z Giersch
-! Allocation statements, comments, naming of variables revised and _wp added to real type values
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Revise error messages for generic tunnel setup.
-!
-! 4346 2019-12-18 11:55:56Z motisi
-! Introduction of wall_flags_total_0, which currently sets bits based on static topography
-! information used in wall_flags_static_0
-!
-! 4340 2019-12-16 08:17:03Z Giersch
-! Topography closed channel flow with symmetric boundaries implemented
-!
-! 4329 2019-12-10 15:46:36Z motisi
-! Renamed wall_flags_0 to wall_flags_static_0
-!
-! 4328 2019-12-09 18:53:04Z suehring
-! Minor change in nzb_max computation. Commentation added.
-!
-! 4314 2019-11-29 10:29:20Z suehring
-! Set additional topography flag 4 to mark topography grid points emerged from the filtering process.
-!
-! 4294 2019-11-13 18:34:16Z suehring
-! Bugfix, always set bit 5 and 6 of wall_flags, indicating terrain- and building surfaces in all
-! cases, in order to enable terrain-following output also when no land- or urban-surface model is
-! applied.
-!
-! 4265 2019-10-15 16:16:24Z suehring
-! Bugfix for last commit, exchange oro_max variable only when it is allocated (not necessarily the
-! case when topography is input from ASCII file).
-!
-! 4245 2019-09-30 08:40:37Z pavelkrc
-! Store oro_max (building z-offset) in 2D for building surfaces
-!
-! 4189 2019-08-26 16:19:38Z suehring
-! - Add check for proper setting of namelist parameter topography
-! - Set flag to indicate land surfaces in case no topography is provided
-!
-! 4182 2019-08-22 15:20:23Z scharf
-! Corrected "Former revisions" section
-!
-! 4168 2019-08-16 13:50:17Z suehring
-! Pre-calculate topography top index and store it on an array (replaces former functions
-! get_topography_top_index)
-!
-! 4159 2019-08-15 13:31:35Z suehring
-! Revision of topography processing. This was not consistent between 2D and 3D buildings.
-!
-! 4144 2019-08-06 09:11:47Z raasch
-! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
-!
-! 4115 2019-07-24 12:50:49Z suehring
-! Bugfix in setting near-surface flag 24, inidicating wall-bounded grid points
-!
-! 4110 2019-07-22 17:05:21Z suehring
-! - Separate initialization of advection flags for momentum and scalars.
-! - Change subroutine interface for ws_init_flags_scalar to pass boundary flags
-!
-! 4109 2019-07-22 17:00:34Z suehring
-! Fix bad commit
-!
-! 3926 2019-04-23 12:56:42Z suehring
-! Minor bugfix in building mapping when all building IDs in the model domain are missing
-!
-! 3857 2019-04-03 13:00:16Z knoop
-! In projection of non-building 3D objects onto numerical grid remove dependency on building_type
-!
-! 3763 2019-02-25 17:33:49Z suehring
-! Replace work-around for ghost point exchange of 1-byte arrays with specific routine as already
-! done in other routines
-!
-! 3761 2019-02-25 15:31:42Z raasch
-! unused variables removed
-!
-! 3661 2019-01-08 18:22:50Z suehring
-! Remove setting of nzb_max to nzt at non-cyclic boundary PEs, instead, order degradation of
-! advection scheme is handeled directly in advec_ws
-!
-! 3655 2019-01-07 16:51:22Z knoop
-! Comment added
+! $Log: init_grid.f90,v $
+! Revision 1.17  2006/08/22 14:00:05  raasch
+! +dz_max to limit vertical stretching,
+! bugfix in index array initialization for line- or point-like topography
+! structures
+!
+! Revision 1.16  2006/03/03 14:28:31  letzel
+! call of user_init_grid now requires the actual parameter nzb_local
+!
+! Revision 1.15  2006/02/24 16:05:59  raasch
+! Error removed: l_wall modification (multiplication with wall adjustment
+! factor and ghost point exchange) must be taken out of the if-clause (see end
+! of this routine)
+!
+! Revision 1.14  2006/02/23 12:30:59  raasch
+! Definition of index and wall arrays describing topography
+!
+! Revision 1.13  2002/12/19 15:38:38  raasch
+! Calculation of dl_grid removed, STOP statement replaced by call of subroutine
+! local_stop
+!
+! Revision 1.12  2001/07/20 13:06:33  raasch
+! +dzu_mg, dzw_mg, f1_mg, f2_mg, f3_mg
+!
+! Revision 1.11  2001/03/30 07:31:20  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.10  2001/01/22 19:35:19  letzel
+! All comments translated into English.
+!
+! Revision 1.9  2001/01/22 07:06:16  raasch
+! Module test_variables removed
+!
+! Revision 1.8  1999/02/05 09:08:32  raasch
+! Erweiterung von dzw um einen Gitterpunkt nach oben fuer Upstream-Spline-
+! Verfahren
+!
+! Revision 1.7  1998/07/06 12:16:43  raasch
+! + USE test_variables
+!
+! Revision 1.6  1998/03/18 20:13:16  raasch
+! dz wird unveraendert gelassen (hatte bisher den Wert der groessten,
+! gestreckten) Gitterweite
+!
+! Revision 1.5  1997/09/19 07:43:27  raasch
+! +dd2zu, dl_grid, l_grid
+!
+! Revision 1.4  1997/09/12 06:26:02  raasch
+! Kehrwerte der Gitterweitenquadrate werden berechnet
+!
+! Revision 1.3  1997/09/09 08:29:12  raasch
+! Kehrwerte der Gitterweiten werden berechnet
+!
+! Revision 1.2  1997/08/26 06:31:11  raasch
+! Berechnung der Vertikalniveaus und der Gitterweiten
 !
 ! Revision 1.1  1997/08/11 06:17:45  raasch
@@ -149,439 +69,72 @@
 !
 ! Description:
-! -------------------------------------------------------------------------------------------------!
-!> Creating grid depending constants
-!> @todo: Rearrange topo flag list
-!> @todo: reference 3D buildings on top of orography is not tested and may need further improvement
-!>        for steep slopes
-!> @todo: Use more advanced setting of building type at filled holes
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE init_grid
-
-    USE arrays_3d,                                                                                 &
-        ONLY:  dd2zu, ddzu, ddzu_pres, ddzw, dzu, dzw, x, xu, y, yv, zu, zw
-
-    USE control_parameters,                                                                        &
-        ONLY:  constant_flux_layer, dz, dz_max, dz_stretch_factor,                                 &
-               dz_stretch_factor_array, dz_stretch_level, dz_stretch_level_end,                    &
-               dz_stretch_level_end_index, dz_stretch_level_start_index,                           &
-               dz_stretch_level_start, message_string,                                             &
-               number_stretch_level_end,                                                           &
-               number_stretch_level_start,                                                         &
-               ocean_mode,                                                                         &
-               psolver,                                                                            &
-               symmetry_flag,                                                                      &
-               topography,                                                                         &
-               use_surface_fluxes
-
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddx2, ddy, ddy2, dx, dx2, dy, dy2, zu_s_inner, zw_w_inner
-
-    USE indices,                                                                                   &
-        ONLY:  nbgp,                                                                               &
-               nx,                                                                                 &
-               nxl,                                                                                &
-               nxlg,                                                                               &
-               nxr,                                                                                &
-               nxrg,                                                                               &
-               ny,                                                                                 &
-               nyn,                                                                                &
-               nyng,                                                                               &
-               nys,                                                                                &
-               nysg,                                                                               &
-               nz,                                                                                 &
-               nzb,                                                                                &
-               nzb_diff,                                                                           &
-               nzb_max,                                                                            &
-               nzt,                                                                                &
-               topo_top_ind,                                                                       &
-               topo_min_level
-
-    USE kinds
-
+! ------------
+! Creating grid depending constants
+!------------------------------------------------------------------------------!
+
+    USE arrays_3d
+    USE control_parameters
+    USE grid_variables
+    USE indices
     USE pegrid
 
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i             !< index variable along x
-    INTEGER(iwp) ::  j             !< index variable along y
-    INTEGER(iwp) ::  k             !< index variable along z
-    INTEGER(iwp) ::  k_top         !< topography top index on local PE
-    INTEGER(iwp) ::  n             !< loop variable for stretching
-    INTEGER(iwp) ::  number_dz     !< number of user-specified dz values
-    INTEGER(iwp) ::  nzb_local_max !< vertical grid index of maximum topography height
-    INTEGER(iwp) ::  nzb_local_min !< vertical grid index of minimum topography height
-
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  topo !< input array for 3D topography and dummy array for setting "outer"-flags
-
-    REAL(wp) ::  dz_level_end  !< distance between calculated height level for u/v-grid and user-specified end level for stretching
-    REAL(wp) ::  dz_stretched  !< stretched vertical grid spacing
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  min_dz_stretch_level_end !< Array that contains all minimum heights where the stretching
-                                                                     !< can end
-
-
-!
-!-- Calculation of horizontal array bounds including ghost layers
-    nxlg = nxl - nbgp
-    nxrg = nxr + nbgp
-    nysg = nys - nbgp
-    nyng = nyn + nbgp
+    INTEGER ::  bh, blx, bly, bxl, bxr, byn, bys, i, i_center, j, j_center, k, &
+                l, nzb_si, nzt_l, vi
+
+    INTEGER, DIMENSION(:), ALLOCATABLE   ::  vertical_influence
+
+    INTEGER, DIMENSION(:,:), ALLOCATABLE ::  corner_nl, corner_nr, corner_sl,  &
+                                             corner_sr, wall_l, wall_n, wall_r,&
+                                             wall_s, nzb_local, nzb_tmp
+
+    REAL    ::  dx_l, dy_l, dz_stretched
+
+    REAL, DIMENSION(0:ny,0:nx)          ::  topo_height
+
+    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  distance
 
 !
 !-- Allocate grid arrays
-    ALLOCATE( x(0:nx) )
-    ALLOCATE( xu(0:nx) )
-
-    DO i = 0, nx
-       xu(i) = i * dx
-       x(i)  = i * dx + 0.5_wp * dx
-    ENDDO
-
-    ALLOCATE( y(0:ny) )
-    ALLOCATE( yv(0:ny) )
-
-    DO j = 0, ny
-       yv(j) = j * dy
-       y(j)  = j * dy + 0.5_wp * dy
-    ENDDO
-
-    ALLOCATE( ddzu(1:nzt+1) )
-    ALLOCATE( ddzw(1:nzt+1) )
-    ALLOCATE( dd2zu(1:nzt) )
-    ALLOCATE( dzu(1:nzt+1) )
-    ALLOCATE( dzw(1:nzt+1) )
-    ALLOCATE( zu(nzb:nzt+1) )
-    ALLOCATE( zw(nzb:nzt+1) )
-
-!
-!-- For constructing an appropriate grid, the vertical grid spacing dz has to be specified with a
-!-- non-negative value in the parameter file.
-    IF ( dz(1) == -1.0_wp )  THEN
-       message_string = 'missing dz'
-       CALL message( 'init_grid', 'PA0200', 1, 2, 0, 6, 0 )
-    ELSEIF ( dz(1) <= 0.0_wp )  THEN
-       WRITE( message_string, * ) 'dz=',dz(1),' <= 0.0'
-       CALL message( 'init_grid', 'PA0201', 1, 2, 0, 6, 0 )
+    ALLOCATE( ddzu(1:nzt+1), ddzw(1:nzt+1), dd2zu(1:nzt), dzu(1:nzt+1), &
+              dzw(1:nzt+1), l_grid(1:nzt), zu(0:nzt+1), zw(0:nzt+1) )
+
+!
+!-- Compute height of u-levels from constant grid length and dz stretch factors
+    IF ( dz == -1.0 )  THEN
+       IF ( myid == 0 )  PRINT*,'+++ init_grid:  missing dz'
+       CALL local_stop
+    ELSEIF ( dz <= 0.0 )  THEN
+       IF ( myid == 0 )  PRINT*,'+++ init_grid:  dz=',dz,' <= 0.0'
+       CALL local_stop
     ENDIF
-
-!
-!-- Initialize dz_stretch_level_start with the value of dz_stretch_level if it was set by the user.
-    IF ( dz_stretch_level /= -9999999.9_wp ) THEN
-       dz_stretch_level_start(1) = dz_stretch_level
-    ENDIF
-
-!
-!-- Determine number of dz values and stretching levels specified by the user to allow right
-!-- controlling of the stretching mechanism and to perform error checks. The additional requirement
-!-- that dz /= dz_max for counting number of user-specified dz values is necessary. Otherwise
-!-- restarts would abort if the old stretching mechanism with dz_stretch_level is used (Attention:
-!-- The user is not allowed to specify a dz value equal to the default of dz_max = 999.0).
-    number_dz = COUNT( dz /= -1.0_wp  .AND.  dz /= dz_max)
-    number_stretch_level_start = COUNT( dz_stretch_level_start /= -9999999.9_wp )
-    number_stretch_level_end = COUNT( dz_stretch_level_end /= 9999999.9_wp )
-
-!
-!-- The number of specified end levels +1 has to be the same as the number
-!-- of specified dz values
-    IF ( number_dz /= number_stretch_level_end + 1 ) THEN
-       WRITE( message_string, * )  'The number of values for dz = ', number_dz,                    &
-                                   'has to be the same as& ', 'the number of values for ',         &
-                                   'dz_stretch_level_end + 1 = ', number_stretch_level_end+1
-       CALL message( 'init_grid', 'PA0156', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- The number of specified start levels has to be the same or one less than the number of specified
-!-- dz values
-    IF ( number_dz /= number_stretch_level_start + 1  .AND.                                        &
-         number_dz /= number_stretch_level_start )  THEN
-       WRITE( message_string, * )  'The number of values for dz = ', number_dz,                    &
-                                   'has to be the same as or one ',                                &
-                                   'more than& the number of values for ',                         &
-                                   'dz_stretch_level_start = ', number_stretch_level_start
-       CALL message( 'init_grid', 'PA0211', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!-- The number of specified start levels has to be the same or one more than the number of specified
-!-- end levels
-    IF ( number_stretch_level_start /= number_stretch_level_end + 1  .AND.                         &
-         number_stretch_level_start /= number_stretch_level_end ) THEN
-       WRITE( message_string, * )  'The number of values for ',                                    &
-                                   'dz_stretch_level_start = ', dz_stretch_level_start,            &
-                                   'has to be the ', 'same or one more than& the number of ',      &
-                                   'values for dz_stretch_level_end = ', number_stretch_level_end
-       CALL message( 'init_grid', 'PA0216', 1, 2, 0, 6, 0 )
-    ENDIF
-
-!
-!-- Initialize dz for the free atmosphere with the value of dz_max
-    IF ( dz(number_stretch_level_start+1) == -1.0_wp  .AND.  number_stretch_level_start /= 0 ) THEN
-       dz(number_stretch_level_start+1) = dz_max
-    ENDIF
-
-!
-!-- Initialize the stretching factor if (infinitely) stretching in the free atmosphere is desired
-!-- (dz_stretch_level_end was not specified for the free atmosphere)
-    IF ( number_stretch_level_start == number_stretch_level_end + 1 )  THEN
-       dz_stretch_factor_array(number_stretch_level_start) = dz_stretch_factor
-    ENDIF
-
-!
-!-- Allocation of arrays for stretching
-    ALLOCATE( min_dz_stretch_level_end(number_stretch_level_start) )
-
-!
-!-- Define the vertical grid levels. Start with atmosphere branch
-    IF ( .NOT. ocean_mode )  THEN
-
-!
-!--    The stretching region has to be large enough to allow for a smooth transition between two
-!--    different grid spacings. The number 4 is an empirical value.
-       DO n = 1, number_stretch_level_start
-          min_dz_stretch_level_end(n) = dz_stretch_level_start(n) + 4 * MAX( dz(n),dz(n+1) )
-       ENDDO
-
-       IF ( ANY( min_dz_stretch_level_end(1:number_stretch_level_start) >                          &
-                 dz_stretch_level_end(1:number_stretch_level_start) ) )  THEN
-          message_string= 'Each dz_stretch_level_end has to be larger ' //                         &
-                          'than its corresponding value for &' //                                  &
-                          'dz_stretch_level_start + 4*MAX(dz(n),dz(n+1)) '//                       &
-                          'to allow for smooth grid stretching'
-          CALL message( 'init_grid', 'PA0224', 1, 2, 0, 6, 0 )
+!
+!-- Since the w-level lies on the surface, the first u-level (staggered!) lies
+!-- below the surface (used for "mirror" boundary condition).
+!-- The first u-level above the surface corresponds to the top of the 
+!-- Prandtl-layer.
+    zu(0) = - dz * 0.5
+    zu(1) =   dz * 0.5
+
+    dz_stretch_level_index = nzt+1
+    dz_stretched = dz
+    DO  k = 2, nzt+1
+       IF ( dz_stretch_level <= zu(k-1)  .AND.  dz_stretched < dz_max )  THEN
+          dz_stretched = dz_stretched * dz_stretch_factor
+          dz_stretched = MIN( dz_stretched, dz_max )
+          IF ( dz_stretch_level_index == nzt+1 )  dz_stretch_level_index = k-1
        ENDIF
-
-!
-!--    Stretching must not be applied within the surface layer (first two grid points). For the
-!--    default case dz_stretch_level_start is negative. Therefore the absolut value is checked here.
-       IF ( ANY( ABS( dz_stretch_level_start ) <= dz(1) * 1.5_wp ) ) THEN
-          WRITE( message_string, * )  'Each dz_stretch_level_start has to be ',                    &
-                                      'larger than ', dz(1) * 1.5
-          CALL message( 'init_grid', 'PA0226', 1, 2, 0, 6, 0 )
-       ENDIF
-
-!
-!--    The stretching has to start and end on a grid level. Therefore user-specified values are
-!--    mapped to the next lowest level. The calculation of the first level is realized differently
-!--    just because of historical reasons (the advanced/new stretching mechanism was realized in a
-!--    way that results don't change if the old parameters dz_stretch_level, dz_stretch_factor and
-!--    dz_max are used).
-       IF ( number_stretch_level_start /= 0 )  THEN
-          dz_stretch_level_start(1) = INT( (dz_stretch_level_start(1) - dz(1)/2.0) / dz(1) )       &
-                                      * dz(1) + dz(1)/2.0
-       ENDIF
-
-       IF ( number_stretch_level_start > 1 ) THEN
-          DO n = 2, number_stretch_level_start
-             dz_stretch_level_start(n) = INT( dz_stretch_level_start(n) / dz(n) ) * dz(n)
-          ENDDO
-       ENDIF
-
-       IF ( number_stretch_level_end /= 0 ) THEN
-          DO n = 1, number_stretch_level_end
-             dz_stretch_level_end(n) = INT( dz_stretch_level_end(n) / dz(n+1) ) * dz(n+1)
-          ENDDO
-       ENDIF
-
-!
-!--    Determine stretching factor if necessary
-       IF ( number_stretch_level_end >= 1 ) THEN
-          CALL calculate_stretching_factor( number_stretch_level_end )
-       ENDIF
-
-!
-!--    Grid for atmosphere with surface at z=0. This corresponds to k=0 on the w-grid AND
-!--    the u-grid.
-!--    First compute the u- and v-levels.
-!--    The second u-level (k=1) corresponds to the top of the surface layer.
-       zu(0) = 0.0_wp
-       zu(1) = dz(1) * 0.5_wp
-
-!
-!--    Determine u and v height levels considering the possibility of grid stretching in several
-!--    heights.
-       n = 1
-       dz_stretch_level_start_index = nzt+1
-       dz_stretch_level_end_index = nzt+1
-       dz_stretched = dz(1)
-
-!--    The default value of dz_stretch_level_start is negative, thus the first condition is true
-!--    even if no stretching shall be applied. Hence, the second condition is also necessary.
-       DO  k = 2, nzt+1-symmetry_flag
-          IF ( dz_stretch_level_start(n) <= zu(k-1)  .AND.                                         &
-               dz_stretch_level_start(n) /= -9999999.9_wp )  THEN
-             dz_stretched = dz_stretched * dz_stretch_factor_array(n)
-
-             IF ( dz(n) > dz(n+1) )  THEN
-                dz_stretched = MAX( dz_stretched, dz(n+1) ) !Restrict dz_stretched to the user-specified (higher) dz
-             ELSE
-                dz_stretched = MIN( dz_stretched, dz(n+1) ) !Restrict dz_stretched to the user-specified (lower) dz
-             ENDIF
-
-             IF ( dz_stretch_level_start_index(n) == nzt+1 )  dz_stretch_level_start_index(n) = k-1
-
-          ENDIF
-
-          zu(k) = zu(k-1) + dz_stretched
-
-!
-!--       Make sure that the stretching ends exactly at dz_stretch_level_end
-          dz_level_end = ABS( zu(k) - dz_stretch_level_end(n) )
-
-          IF ( dz_level_end  <  dz(n+1) / 3.0 )  THEN
-             zu(k) = dz_stretch_level_end(n)
-             dz_stretched = dz(n+1)
-             dz_stretch_level_end_index(n) = k
-             n = n + 1
-          ENDIF
-       ENDDO
-
-!
-!--    If a closed channel flow is simulated, make sure that grid structure is the same for both
-!--    bottom and top boundary. (Hint: Using a different dz at the bottom and at the top makes no
-!--    sense due to symmetric boundaries where dz should be equal. Therefore, different dz at the
-!--    bottom and top causes an abort (see check_parameters).)
-       IF ( topography == 'closed_channel' )  THEN
-          zu(nzt+1) = zu(nzt) + dz(1) * 0.5_wp
-       ENDIF
-
-!
-!--    Compute the w-levels. They are always staggered half-way between the corresponding u-levels.
-!--    In case of dirichlet bc for u and v at the ground the first u- and w-level (k=0) are defined
-!--    at same height (z=0).
-!--    Per default, the top w-level is extrapolated linearly. In case of a closed channel flow,
-!--    zu(nzt+1) and zw(nzt) must be set explicitely.
-!--    (Hint: Using a different dz at the bottom and at the top makes no sense due to symmetric
-!--    boundaries where dz should be equal. Therefore, different dz at the bottom and top causes an
-!--    abort (see check_parameters).)
-       zw(0) = 0.0_wp
-       DO  k = 1, nzt-symmetry_flag
-          zw(k) = ( zu(k) + zu(k+1) ) * 0.5_wp
-       ENDDO
-       IF ( topography == 'closed_channel' )  THEN
-          zw(nzt)   = zw(nzt-1) + dz(1)
-          zw(nzt+1) = zw(nzt) + dz(1)
-       ELSE
-          zw(nzt+1) = zw(nzt) + 2.0_wp * ( zu(nzt+1) - zw(nzt) )
-       ENDIF
-
-    ELSE !ocean branch
-
-!
-!--    The stretching region has to be large enough to allow for a smooth transition between two
-!--    different grid spacings. The number 4 is an empirical value
-       DO n = 1, number_stretch_level_start
-          min_dz_stretch_level_end(n) = dz_stretch_level_start(n) - 4 * MAX( dz(n),dz(n+1) )
-       ENDDO
-
-       IF ( ANY( min_dz_stretch_level_end (1:number_stretch_level_start) <                         &
-                 dz_stretch_level_end(1:number_stretch_level_start) ) )  THEN
-             message_string= 'Each dz_stretch_level_end has to be less ' //                        &
-                             'than its corresponding value for &' //                               &
-                             'dz_stretch_level_start - 4*MAX(dz(n),dz(n+1)) '//                    &
-                             'to allow for smooth grid stretching'
-             CALL message( 'init_grid', 'PA0224', 1, 2, 0, 6, 0 )
-       ENDIF
-
-!
-!--    Stretching must not be applied close to the surface (last two grid points). For the default
-!--    case dz_stretch_level_start is negative.
-       IF ( ANY( dz_stretch_level_start >= - dz(1) * 1.5_wp ) )  THEN
-          WRITE( message_string, * )  'Each dz_stretch_level_start has to be ',                    &
-                                      'less than ', -dz(1) * 1.5
-             CALL message( 'init_grid', 'PA0226', 1, 2, 0, 6, 0 )
-       ENDIF
-
-!
-!--    The stretching has to start and end on a grid level. Therefore user-specified values are
-!--    mapped to the next highest level. The calculation of the first level is realized differently
-!--    just because of historical reasons (the advanced/new stretching mechanism was realized in a
-!--    way that results don't change if the old parameters dz_stretch_level, dz_stretch_factor and
-!--    dz_max are used)
-       IF ( number_stretch_level_start /= 0 )  THEN
-          dz_stretch_level_start(1) = INT( (dz_stretch_level_start(1) + dz(1)/2.0) / dz(1) )       &
-                                      * dz(1) - dz(1)/2.0
-       ENDIF
-
-       IF ( number_stretch_level_start > 1 )  THEN
-          DO n = 2, number_stretch_level_start
-             dz_stretch_level_start(n) = INT( dz_stretch_level_start(n) / dz(n) ) * dz(n)
-          ENDDO
-       ENDIF
-
-       IF ( number_stretch_level_end /= 0 )  THEN
-          DO n = 1, number_stretch_level_end
-             dz_stretch_level_end(n) = INT( dz_stretch_level_end(n) / dz(n+1) ) * dz(n+1)
-          ENDDO
-       ENDIF
-
-!
-!--    Determine stretching factor if necessary
-       IF ( number_stretch_level_end >= 1 ) THEN
-          CALL calculate_stretching_factor( number_stretch_level_end )
-       ENDIF
-
-!
-!--    Grid for ocean with free water surface is at k=nzt (w-grid).
-!--    In case of neumann bc at the ground the first first u-level (k=0) lies below the first
-!--    w-level (k=0). In case of dirichlet bc the first u- and w-level are defined at same height,
-!--    but staggered from the second level.
-!--    The second u-level (k=1) corresponds to the top of the surface layer.
-!--    z values are negative starting from z=0 (surface)
-       zu(nzt+1) =   dz(1) * 0.5_wp
-       zu(nzt)   = - dz(1) * 0.5_wp
-
-!
-!--    Determine u and v height levels considering the possibility of grid stretching in several
-!--    heights.
-       n = 1
-       dz_stretch_level_start_index = 0
-       dz_stretch_level_end_index = 0
-       dz_stretched = dz(1)
-
-       DO  k = nzt-1, 0, -1
-
-          IF ( dz_stretch_level_start(n) >= zu(k+1) )  THEN
-             dz_stretched = dz_stretched * dz_stretch_factor_array(n)
-
-             IF ( dz(n) > dz(n+1) )  THEN
-                dz_stretched = MAX( dz_stretched, dz(n+1) ) !Restrict dz_stretched to the user-specified (higher) dz
-             ELSE
-                dz_stretched = MIN( dz_stretched, dz(n+1) ) !Restrict dz_stretched to the user-specified (lower) dz
-             ENDIF
-
-             IF ( dz_stretch_level_start_index(n) == 0 )  dz_stretch_level_start_index(n) = k+1
-
-          ENDIF
-
-          zu(k) = zu(k+1) - dz_stretched
-
-!
-!--       Make sure that the stretching ends exactly at dz_stretch_level_end
-          dz_level_end = ABS( zu(k) - dz_stretch_level_end(n) )
-
-          IF ( dz_level_end  < dz(n+1)/3.0 )  THEN
-             zu(k) = dz_stretch_level_end(n)
-             dz_stretched = dz(n+1)
-             dz_stretch_level_end_index(n) = k
-             n = n + 1
-          ENDIF
-       ENDDO
-
-!
-!--    Compute the w-levels. They are always staggered half-way between the corresponding u-levels,
-!--    except for u and v at the ground. In this case the first u- and
-!--    w-level are defined at same height. The top w-level (nzt+1) is not used but set for
-!--    consistency, since w and all scalar variables are defined up to nzt+1.
-       zw(nzt+1) = dz(1)
-       zw(nzt)   = 0.0_wp
-       DO  k = 0, nzt
-          zw(k) = ( zu(k) + zu(k+1) ) * 0.5_wp
-       ENDDO
-
-!
-!--    Like for the atmosphere, the first u-grid and w-grid-level are defined at same height.
-       zu(0) = zw(0)
-
-    ENDIF !End of defining the vertical grid levels
+       zu(k) = zu(k-1) + dz_stretched
+    ENDDO
+
+!
+!-- Compute the u-levels. They are always staggered half-way between the 
+!-- corresponding w-levels. The top w-level is extrapolated linearly.
+    zw(0) = 0.0
+    DO  k = 1, nzt
+       zw(k) = ( zu(k) + zu(k+1) ) * 0.5
+    ENDDO
+    zw(nzt+1) = zw(nzt) + 2.0 * ( zu(nzt+1) - zw(nzt) )
 
 !
